package com.sun.corba.se.impl.encoding;

import java.util.Iterator;
import java.util.Collections;
import java.util.ArrayList;
import java.util.HashMap;
import com.sun.corba.se.impl.corba.TypeCodeImpl;
import org.omg.CORBA.ORB;
import org.omg.CORBA.Context;
import java.math.BigDecimal;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import java.io.Serializable;
import org.omg.CORBA.Object;
import java.io.IOException;
import java.util.Map;
import org.omg.CORBA_2_3.portable.InputStream;

public class WrapperInputStream extends InputStream implements TypeCodeReader
{
    private CDRInputStream stream;
    private Map typeMap;
    private int startPos;
    
    public WrapperInputStream(CDRInputStream stream) {
        this.typeMap = null;
        this.startPos = 0;
        this.stream = stream;
        this.startPos = this.stream.getPosition();
    }
    
    public int read() throws IOException {
        return this.stream.read();
    }
    
    public int read(byte[] array) throws IOException {
        return this.stream.read(array);
    }
    
    public int read(byte[] array, int n, int n2) throws IOException {
        return this.stream.read(array, n, n2);
    }
    
    public long skip(long n) throws IOException {
        return this.stream.skip(n);
    }
    
    public int available() throws IOException {
        return this.stream.available();
    }
    
    public void close() throws IOException {
        this.stream.close();
    }
    
    public void mark(int n) {
        this.stream.mark(n);
    }
    
    public void reset() {
        this.stream.reset();
    }
    
    public boolean markSupported() {
        return this.stream.markSupported();
    }
    
    public int getPosition() {
        return this.stream.getPosition();
    }
    
    public void consumeEndian() {
        this.stream.consumeEndian();
    }
    
    public boolean read_boolean() {
        return this.stream.read_boolean();
    }
    
    public char read_char() {
        return this.stream.read_char();
    }
    
    public char read_wchar() {
        return this.stream.read_wchar();
    }
    
    public byte read_octet() {
        return this.stream.read_octet();
    }
    
    public short read_short() {
        return this.stream.read_short();
    }
    
    public short read_ushort() {
        return this.stream.read_ushort();
    }
    
    public int read_long() {
        return this.stream.read_long();
    }
    
    public int read_ulong() {
        return this.stream.read_ulong();
    }
    
    public long read_longlong() {
        return this.stream.read_longlong();
    }
    
    public long read_ulonglong() {
        return this.stream.read_ulonglong();
    }
    
    public float read_float() {
        return this.stream.read_float();
    }
    
    public double read_double() {
        return this.stream.read_double();
    }
    
    public String read_string() {
        return this.stream.read_string();
    }
    
    public String read_wstring() {
        return this.stream.read_wstring();
    }
    
    public void read_boolean_array(boolean[] array, int n, int n2) {
        this.stream.read_boolean_array(array, n, n2);
    }
    
    public void read_char_array(char[] array, int n, int n2) {
        this.stream.read_char_array(array, n, n2);
    }
    
    public void read_wchar_array(char[] array, int n, int n2) {
        this.stream.read_wchar_array(array, n, n2);
    }
    
    public void read_octet_array(byte[] array, int n, int n2) {
        this.stream.read_octet_array(array, n, n2);
    }
    
    public void read_short_array(short[] array, int n, int n2) {
        this.stream.read_short_array(array, n, n2);
    }
    
    public void read_ushort_array(short[] array, int n, int n2) {
        this.stream.read_ushort_array(array, n, n2);
    }
    
    public void read_long_array(int[] array, int n, int n2) {
        this.stream.read_long_array(array, n, n2);
    }
    
    public void read_ulong_array(int[] array, int n, int n2) {
        this.stream.read_ulong_array(array, n, n2);
    }
    
    public void read_longlong_array(long[] array, int n, int n2) {
        this.stream.read_longlong_array(array, n, n2);
    }
    
    public void read_ulonglong_array(long[] array, int n, int n2) {
        this.stream.read_ulonglong_array(array, n, n2);
    }
    
    public void read_float_array(float[] array, int n, int n2) {
        this.stream.read_float_array(array, n, n2);
    }
    
    public void read_double_array(double[] array, int n, int n2) {
        this.stream.read_double_array(array, n, n2);
    }
    
    public org.omg.CORBA.Object read_Object() {
        return this.stream.read_Object();
    }
    
    public Serializable read_value() {
        return this.stream.read_value();
    }
    
    public TypeCode read_TypeCode() {
        return this.stream.read_TypeCode();
    }
    
    public Any read_any() {
        return this.stream.read_any();
    }
    
    public Principal read_Principal() {
        return this.stream.read_Principal();
    }
    
    public BigDecimal read_fixed() {
        return this.stream.read_fixed();
    }
    
    public Context read_Context() {
        return this.stream.read_Context();
    }
    
    public ORB orb() {
        return this.stream.orb();
    }
    
    public void addTypeCodeAtPosition(TypeCodeImpl typeCodeImpl, int value) {
        if (this.typeMap == null) {
            this.typeMap = new HashMap(16);
        }
        this.typeMap.put(new Integer(value), typeCodeImpl);
    }
    
    public TypeCodeImpl getTypeCodeAtPosition(int value) {
        if (this.typeMap == null) {
            return null;
        }
        return (TypeCodeImpl)this.typeMap.get(new Integer(value));
    }
    
    public void setEnclosingInputStream(InputStream inputStream) {
    }
    
    public TypeCodeReader getTopLevelStream() {
        return this;
    }
    
    public int getTopLevelPosition() {
        return this.getPosition() - this.startPos;
    }
    
    public void performORBVersionSpecificInit() {
        this.stream.performORBVersionSpecificInit();
    }
    
    public void resetCodeSetConverters() {
        this.stream.resetCodeSetConverters();
    }
    
    public void printTypeMap() {
        System.out.println("typeMap = {");
        ArrayList list = new ArrayList(this.typeMap.keySet());
        Collections.sort(list);
        for (Integer n : list) {
            System.out.println("  key = " + (int)n + ", value = " + ((TypeCodeImpl)this.typeMap.get(n)).description());
        }
        System.out.println("}");
    }
}
